//
//  HomeLinDanController.swift
//  IFS
//
//  Created by Tiank on 2018/9/5.
//  Copyright © 2018年 上海勾芒信息科技有限公司. All rights reserved.
//

import UIKit
import RxSwift
import RxCocoa
import SwiftyJSON

class HomeLinDanController: UIViewController {
    /// RxSwift自动释放
    let disposeBag = DisposeBag()
    var model:TodoData!
    /// 工单详情ViewModel
    lazy final var orderDetailViewModel: RepairOrderDetailViewModel = {
        var orderDetailViewModel = RepairOrderDetailViewModel()
        return orderDetailViewModel
    }()
    @IBOutlet weak var orderNumLabel: UILabel!
    @IBOutlet weak var timeLabel: UILabel!
    /// 子工单详情ViewModel
    lazy final var childBillViewModel: ReparirChildBillViewModel = {
        var childBillViewModel = ReparirChildBillViewModel()
        return childBillViewModel
    }()
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    func requestDetail(){
        childBillViewModel.queryChildBillDetailAction(self.model.entityUuid).subscribe {[weak self] (event) in
            self?.updateUI()
        }.disposed(by: disposeBag)
    }
    func updateUI(){
        orderNumLabel.text = self.childBillViewModel.childBillDetailData.executeNo
        timeLabel.text = self.childBillViewModel.childBillDetailData.createTime
    }
    @IBAction func linDanAction(_ sender: UIButton) {
        ShowAlertView(hint, "请确认是否领单?", [cancel,sure], .alert, {[weak self] (index) in
            if index == kZERO { return }
            self?.orderDetailViewModel.getChildBillAction(self?.model.entityUuid ?? "").subscribe(onNext: {[weak self] () in
                self?.requestMessage()
                self?.goDetail()
            }).disposed(by: self!.disposeBag)
        })

//        self.orderDetailViewModel.getChildBillAction(model.entityUuid).subscribe(onNext: {[weak self] () in
//            self?.requestMessage()
//            self?.goDetail()
//        }).disposed(by: self.disposeBag)
    }
    func goDetail(){
        
        NotificationCenter.default.post(name: Notification.Name(rawValue: UPDATE_TODO_LIST), object: nil)
        let childBillVc = RepairOrderEditSonOrderViewController.instantiateViewController(.Function) as! RepairOrderEditSonOrderViewController
        childBillVc.billModel = BillDetailExecute(fromJson: JSON(model.toDictionary()))
        childBillVc.billModel.uuid = model.entityUuid
        pushVC(childBillVc)
        self.navigationController?.viewControllers = (self.navigationController?.viewControllers.filter({ (vc) -> Bool in
            return vc != self
        }))!
        
    }
    func requestMessage(){
        Network.request(target: Service.ChildOrderComplete(self.model.entityUuid, "drew"), success: { (json) in
    
        }, failure: { (error) in
            
        })
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
